KDE 4.9 PyKDE API Reference

- KDE's Python API

# KComboBox Class Reference

`from PyKDE4.kdeui import *`

Inherits: QComboBox → QWidget → QObject,KCompletionBase
Subclasses: KDateComboBox, KFontComboBox, KHistoryComboBox, KTimeComboBox, Sonnet.DictionaryComboBox

## Detailed Description

An enhanced combo box.

A combined button, line-edit and a popup list widget.

Detail

This widget inherits from QComboBox and implements the following additional functionalities: a completion object that provides both automatic and manual text completion as well as text rotation features, configurable key-bindings to activate these features, and a popup-menu item that can be used to allow the user to change the text completion mode on the fly.

To support these new features KComboBox emits a few additional signals such as completion( const QString& ) and textRotation( KeyBindingType ). The completion signal can be connected to a slot that will assist the user in filling out the remaining text while the rotation signal can be used to traverse through all possible matches whenever text completion results in multiple matches. Additionally, a returnPressed() and a returnPressed( const QString& ) signals are emitted when the user presses the Enter/Return key.

KCombobox by default creates a completion object when you invoke the completionObject( bool ) member function for the first time or explicitly use setCompletionObject( KCompletion*, bool ) to assign your own completion object. Additionally, to make this widget more functional, KComboBox will by default handle text rotation and completion events internally whenever a completion object is created through either one of the methods mentioned above. If you do not need this functionality, simply use KCompletionBase.setHandleSignals(bool) or alternatively set the boolean parameter in the setCompletionObject call to false.

Beware: The completion object can be deleted on you, especially if a call such as setEditable(false) is made. Store the pointer at your own risk, and consider using QGuardedPtr<KCompletion>.

The default key-bindings for completion and rotation is determined from the global settings in KStandardShortcut. These values, however, can be overridden locally by invoking KCompletionBase.setKeyBinding(). The values can easily be reverted back to the default setting, by simply calling useGlobalSettings(). An alternate method would be to default individual key-bindings by usning setKeyBinding() with the default second argument.

A non-editable combobox only has one completion mode, CompletionAuto. Unlike an editable combobox the CompletionAuto mode, works by matching any typed key with the first letter of entries in the combobox. Please note that if you call setEditable( false ) to change an editable combobox to a non-editable one, the text completion object associated with the combobox will no longer exist unless you created the completion object yourself and assigned it to this widget or you called setAutoDeleteCompletionObject( false ). In other words do not do the following:

     KComboBox* combo = new KComboBox(true, this);
     KCompletion* comp = combo->completionObject();
     combo->setEditable( false );
     comp->clear(); // CRASH: completion object does not exist anymore.

A read-only KComboBox will have the same background color as a disabled KComboBox, but its foreground color will be the one used for the read-write mode. This differs from QComboBox's implementation and is done to give visual distinction between the three different modes: disabled, read-only, and read-write.

Usage

To enable the basic completion feature:

     KComboBox *combo = new KComboBox( true, this );
     KCompletion *comp = combo->completionObject();
     // Connect to the return pressed signal - optional
     connect(combo,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&)));

     // Provide the to be completed strings. Note that those are separate from the combo's
     // contents.
     comp->insertItems( someQStringList );

To use your own completion object:

     KComboBox *combo = new KComboBox( this );
     KUrlCompletion *comp = new KUrlCompletion();
     combo->setCompletionObject( comp );
     // Connect to the return pressed signal - optional
     connect(combo,SIGNAL(returnPressed(const QString&)),comp,SLOT(addItem(const QString&)));

Note that you have to either delete the allocated completion object when you don't need it anymore, or call setAutoDeleteCompletionObject( true );

Miscellaneous function calls:

     // Tell the widget not to handle completion and rotation
     combo->setHandleSignals( false );
     // Set your own completion key for manual completions.
     combo->setKeyBinding( KCompletionBase.TextCompletion, Qt.End );

"KDE Combo Boxes, one non-editable, one editable with KUrlCompletion"

Author:
  Dawit Alemayehu <adawit@kde.org>

## Signals

| aboutToShowContextMenu (QMenu p)
| completion (QString a0)
| completionModeChanged (KGlobalSettings.Completion a0)
| returnPressed ()
| returnPressed (QString a0)
| substringCompletion (QString a0)
| textRotation (KCompletionBase.KeyBindingType a0)

## Methods

| __init__ (self, QWidget parent=0)
| __init__ (self, bool rw, QWidget parent=0)
| addUrl (self, KUrl url)
| addUrl (self, QIcon icon, KUrl url)
bool | autoCompletion (self)
| changeURL (self, KUrl url, int index)
| changeURL (self, QPixmap pixmap, KUrl url, int index)
| changeUrl (self, int index, KUrl url)
| changeUrl (self, int index, QIcon icon, KUrl url)
KCompletionBox | completionBox (self, bool create=1)
bool | contains (self, QString text)
| create (self, long a0=0, bool initializeWindow=1, bool destroyOldWindow=1)
int | cursorPosition (self)
bool | eventFilter (self, QObject a0, QEvent a1)
| insertURL (self, KUrl url, int index=-1)
| insertURL (self, QPixmap pixmap, KUrl url, int index=-1)
| insertUrl (self, int index, KUrl url)
| insertUrl (self, int index, QIcon icon, KUrl url)
| makeCompletion (self, QString a0)
QSize | minimumSizeHint (self)
| rotateText (self, KCompletionBase.KeyBindingType type)
| setAutoCompletion (self, bool autocomplete)
| setCompletedItems (self, QStringList items, bool autosubject=1)
| setCompletedText (self, QString a0)
| setCompletedText (self, QString a0, bool a1)
| setContextMenuEnabled (self, bool showMenu)
| setCurrentItem (self, QString item, bool insert=0, int index=-1)
| setEditUrl (self, KUrl url)
| setEditable (self, bool editable)
| setLineEdit (self, QLineEdit a0)
| setTrapReturnKey (self, bool trap)
| setUrlDropsEnabled (self, bool enable)
bool | trapReturnKey (self)
bool | urlDropsEnabled (self)
| wheelEvent (self, QWheelEvent ev)

## Signal Documentation

aboutToShowContextMenu | ( | QMenu | p
| ) |  |  |

Emitted before the context menu is displayed.

The signal allows you to add your own entries into the context menu. Note that you MUST NOT store the pointer to the QPopupMenu since it is created and deleted on demand. Otherwise, you can crash your app.

Parameters:

  | p | the context menu about to be displayed

Signal syntax:
  `QObject.connect(source, SIGNAL("aboutToShowContextMenu(QMenu*)"), target_slot)`

completion | ( | QString | a0
| ) |  |  |

Emitted when the completion key is pressed.

The argument is the current text being edited.

Note that this signal is not available when the widget is non-editable or the completion mode is set to KGlobalSettings.CompletionNone.

Signal syntax:
  `QObject.connect(source, SIGNAL("completion(const QString&)"), target_slot)`

completionModeChanged | ( | KGlobalSettings.Completion | a0
| ) |  |  |

Emitted whenever the completion mode is changed by the user through the context menu.

Signal syntax:
  `QObject.connect(source, SIGNAL("completionModeChanged(KGlobalSettings::Completion)"), target_slot)`

returnPressed | ( |  | ) |

Emitted when the user presses the Enter key.

The argument is the current text being edited. This signal is just like returnPressed() except it contains the current text as its argument.

Note that this signal is only emitted when the widget is editable.

Signal syntax:
  `QObject.connect(source, SIGNAL("returnPressed()"), target_slot)`

returnPressed | ( | QString | a0
| ) |  |  |

Emitted when the user presses the Enter key.

The argument is the current text being edited. This signal is just like returnPressed() except it contains the current text as its argument.

Note that this signal is only emitted when the widget is editable.

Signal syntax:
  `QObject.connect(source, SIGNAL("returnPressed(const QString&)"), target_slot)`

substringCompletion | ( | QString | a0
| ) |  |  |

Emitted when the shortcut for substring completion is pressed.

Signal syntax:
  `QObject.connect(source, SIGNAL("substringCompletion(const QString&)"), target_slot)`

textRotation | ( | KCompletionBase.KeyBindingType | a0
| ) |  |  |

Emitted when the text rotation key-bindings are pressed.

The argument indicates which key-binding was pressed. In this case this can be either one of four values: PrevCompletionMatch, NextCompletionMatch, RotateUp or RotateDown. See KCompletionBase.setKeyBinding() for details.

Note that this signal is NOT emitted if the completion mode is set to CompletionNone.

Signal syntax:
  `QObject.connect(source, SIGNAL("textRotation(KCompletionBase::KeyBindingType)"), target_slot)`

## Method Documentation

__init__ | ( | self, |
|  | QWidget | parent=0
| ) |  |  |

Constructs a read-only or rather select-only combo box with a parent object and a name.

Parameters:

  | parent | The parent object of this widget

__init__ | ( | self, |
|  | bool | rw,
|  | QWidget | parent=0
| ) |  |  |

Constructs a "read-write" or "read-only" combo box depending on the value of the first argument( rw ) with a parent, a name.

Parameters:

  | rw | When true, widget will be editable.
  | parent | The parent object of this widget.

addUrl | ( | self, |
|  | KUrl | url
| ) |  |  |

Appends url with the icon &p icon to the combobox. KUrl.prettyUrl() is used so that the url is properly decoded for displaying.

addUrl | ( | self, |
|  | QIcon | icon,
|  | KUrl | url
| ) |  |  |

Appends url with the icon &p icon to the combobox. KUrl.prettyUrl() is used so that the url is properly decoded for displaying.

bool autoCompletion | ( |  | self ) |

Re-implemented from QComboBox.

Returns true if the current completion mode is set to automatic. See its more comprehensive replacement completionMode().

Returns:
  true when completion mode is automatic.

changeURL | ( | self, |
|  | KUrl | url,
|  | int | index
| ) |  |  |

changeURL | ( | self, |
|  | QPixmap | pixmap,
|  | KUrl | url,
|  | int | index
| ) |  |  |

changeUrl | ( | self, |
|  | int | index,
|  | KUrl | url
| ) |  |  |

Replaces the item at position index with url and icon icon. KUrl.prettyUrl() is used so that the url is properly decoded for displaying.

changeUrl | ( | self, |
|  | int | index,
|  | QIcon | icon,
|  | KUrl | url
| ) |  |  |

Replaces the item at position index with url and icon icon. KUrl.prettyUrl() is used so that the url is properly decoded for displaying.

KCompletionBox completionBox | ( | self, |
|  | bool | create=1
| ) |  |  |

Returns:
  the completion-box, that is used in completion mode KGlobalSettings.CompletionPopup and KGlobalSettings.CompletionPopupAuto. This method will create a completion-box by calling KLineEdit.completionBox, if none is there, yet.

Parameters:

  | create | Set this to false if you don't want the box to be created i.e. to test if it is available.

bool contains | ( | self, |
|  | QString | text
| ) |  |  |

Convenience method which iterates over all items and checks if any of them is equal to text.

If text is an empty string, false is returned.

Returns:
  true if an item with the string text is in the combobox.

create | ( | self, |
|  | long | a0=0,
|  | bool | initializeWindow=1,
|  | bool | destroyOldWindow=1
| ) |  |  |

Reimplemented for internal reasons, the API is not affected.

int cursorPosition | ( |  | self ) |

Returns the current cursor position.

This method always returns a -1 if the combo-box is not editable (read-write).

Returns:
  Current cursor position.

bool eventFilter | ( | self, |
|  | QObject | a0,
|  | QEvent | a1
| ) |  |  |

Re-implemented for internal reasons. API not affected.

insertURL | ( | self, |
|  | KUrl | url,
|  | int | index=-1
| ) |  |  |

Deprecated to reflect Qt api changes

Deprecated:

insertURL | ( | self, |
|  | QPixmap | pixmap,
|  | KUrl | url,
|  | int | index=-1
| ) |  |  |

Deprecated to reflect Qt api changes

Deprecated:

insertUrl | ( | self, |
|  | int | index,
|  | KUrl | url
| ) |  |  |

Inserts url with the pixmap &p pixmap at position index into the combobox. KUrl.prettyUrl() is used so that the url is properly decoded for displaying.

insertUrl | ( | self, |
|  | int | index,
|  | QIcon | icon,
|  | KUrl | url
| ) |  |  |

Inserts url with the pixmap &p pixmap at position index into the combobox. KUrl.prettyUrl() is used so that the url is properly decoded for displaying.

makeCompletion | ( | self, |
|  | QString | a0
| ) |  |  |

Completes text according to the completion mode.

Note: this method is not invoked if the completion mode is set to CompletionNone. Also if the mode is set to CompletionShell and multiple matches are found, this method will complete the text to the first match with a beep to inidicate that there are more matches. Then any successive completion key event iterates through the remaining matches. This way the rotation functionality is left to iterate through the list as usual.

QSize minimumSizeHint | ( |  | self ) |

rotateText | ( | self, |
|  | KCompletionBase.KeyBindingType | type
| ) |  |  |

Iterates through all possible matches of the completed text or the history list.

Depending on the value of the argument, this function either iterates through the history list of this widget or the all possible matches in whenever multiple matches result from a text completion request. Note that the all-possible-match iteration will not work if there are no previous matches, i.e. no text has been completed and the *nix shell history list rotation is only available if the insertion policy for this widget is set either QComobBox.AtTop or QComboBox.AtBottom. For other insertion modes whatever has been typed by the user when the rotation event was initiated will be lost.

Parameters:

  | type | The key-binding invoked.

setAutoCompletion | ( | self, |
|  | bool | autocomplete
| ) |  |  |

Re-implemented from QComboBox.

If true, the completion mode will be set to automatic. Otherwise, it is defaulted to the global setting. This method has been replaced by the more comprehensive setCompletionMode().

Parameters:

  | autocomplete | Flag to enable/disable automatic completion mode.

setCompletedItems | ( | self, |
|  | QStringList | items,
|  | bool | autosubject=1
| ) |  |  |

Sets items into the completion-box if completionMode() is CompletionPopup. The popup will be shown immediately.

setCompletedText | ( | self, |
|  | QString | a0
| ) |  |  |

Sets the completed text in the line-edit appropriately.

This function is an implementation for KCompletionBase.setCompletedText.

setCompletedText | ( | self, |
|  | QString | a0,
|  | bool | a1
| ) |  |  |

Sets the completed text in the line-edit appropriately.

This function is an implementation for KCompletionBase.setCompletedText.

setContextMenuEnabled | ( | self, |
|  | bool | showMenu
| ) |  |  |

Enables or disable the popup (context) menu.

This method only works if this widget is editable, i.e. read-write and allows you to enable/disable the context menu. It does nothing if invoked for a none-editable combo-box.

By default, the context menu is created if this widget is editable. Call this function with the argument set to false to disable the popup menu.

Parameters:

  | showMenu | If true, show the context menu.

Deprecated:
  use setContextMenuPolicy

setCurrentItem | ( | self, |
|  | QString | item,
|  | bool | insert=0,
|  | int | index=-1
| ) |  |  |

Selects the first item that matches item. If there is no such item, it is inserted at position index if insert is true. Otherwise, no item is selected.

setEditUrl | ( | self, |
|  | KUrl | url
| ) |  |  |

Sets url into the edit field of the combobox. It uses KUrl.prettyUrl() so that the url is properly decoded for displaying.

setEditable | ( | self, |
|  | bool | editable
| ) |  |  |

"Re-implemented" so that setEditable(true) creates a KLineEdit instead of QLineEdit.

Note that QComboBox.setEditable is not virtual, so do not use a KComboBox in a QComboBox pointer.

setLineEdit | ( | self, |
|  | QLineEdit | a0
| ) |  |  |

Re-implemented for internal reasons. API remains unaffected. Note that QComboBox.setLineEdit is not virtual in Qt4, do not use a KComboBox in a QComboBox pointer.

NOTE: Only editable comboboxes can have a line editor. As such any attempt to assign a line-edit to a non-editable combobox will simply be ignored.

setTrapReturnKey | ( | self, |
|  | bool | trap
| ) |  |  |

By default, KComboBox recognizes Key_Return and Key_Enter and emits the returnPressed() signals, but it also lets the event pass, for example causing a dialog's default-button to be called.

Call this method with trap equal to true to make KComboBox stop these events. The signals will still be emitted of course.

Only affects read-writable comboboxes.

See also:
  setTrapReturnKey()

setUrlDropsEnabled | ( | self, |
|  | bool | enable
| ) |  |  |

Enables/Disables handling of URL drops. If enabled and the user drops an URL, the decoded URL will be inserted. Otherwise the default behavior of QComboBox is used, which inserts the encoded URL.

Parameters:

  | enable | If true, insert decoded URLs

bool trapReturnKey | ( |  | self ) |

Returns:
  true if keyevents of Key_Return or Key_Enter will be stopped or if they will be propagated.

See also:
  setTrapReturnKey ()

bool urlDropsEnabled | ( |  | self ) |

Returns true when decoded URL drops are enabled

wheelEvent | ( | self, |
|  | QWheelEvent | ev
| ) |  |  |